package edu.berkeley.sbp;
import edu.berkeley.sbp.util.*;
import edu.berkeley.sbp.*;
import edu.berkeley.sbp.*;
import java.io.*;
import java.util.*;
import java.lang.reflect.*;
import java.lang.ref.*;

/** the root superclass for all components of the grammar (terminals, nonterminals, literals, etc) */
public abstract class Element {

    /** if this element always matches exactly one token, return a topology covering exactly those possible tokens, otherwise <tt>null</tt> */
    abstract Topology toAtom();

    Forest epsilonForm() { throw new Error("no epsilon form: " + this); }
    final boolean possiblyEpsilon(Walk.Cache cache) {
        Boolean ret = cache==null ? null : cache.possiblyEpsilon.get(this);
        if (ret != null) return ret.booleanValue();
        ret = new Walk.PossiblyEpsilon().walk(this) ? Boolean.TRUE : Boolean.FALSE;
        if (cache != null) cache.possiblyEpsilon.put(this, ret);
        return ret;
    }
}
